<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>List students</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body>
    <div class="container w-50">
        <div class="text-center m-3">
            <h3>THÔNG TIN SINH VIÊN</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <button class="btn btn-primary" onclick="onBtnLayThongTinClick()">Lấy thông tin</button>
            </div>
            <label class="col-form-label col-sm-4">Số lượng sinh viên:
                <span id="span-num-students" class="text-danger font-weight-bold">1000</span>
            </label>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">Danh sách ID sinh viên:
                <span id="span-id-student-list" class="text-danger">3, 4, 7, 8, 9, 10</span>
            </div>
        </div>
        <br>
        <hr>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-student-id">Nhập Id sinh viên <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-5">
                <input id="input-student-id" placeholder="Nhập id sinh viên ..." class="form-control">
            </div>
            <div class="col-sm-3">
                <button class="btn btn-primary" onclick="onBtnXemChiTietClick()">Xem chi tiết</button>
            </div>
        </div>
        <hr>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-student-code">Student Code</label>
            <div class="col-sm-3">
                <input id="input-student-code" placeholder="Mã sinh viên" class="form-control">
            </div>
            <label class="col-form-label col-sm-3" for="input-username">Username</label>
            <div class="col-sm-3">
                <input id="input-username" placeholder="Username" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-firstname">First name</label>
            <div class="col-sm-3">
                <input id="input-firstname" placeholder="Họ và chữ lót" class="form-control">
            </div>
            <label class="col-form-label col-sm-3" for="input-lastname">Last name</label>
            <div class="col-sm-3">
                <input id="input-lastname" placeholder="Tên" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-birthday">Birthday</label>
            <div class="col-sm-3">
                <input type="text" id="input-birthday" placeholder="Ngày sinh" class="form-control">
            </div>
            <label class="col-form-label col-sm-3" for="input-study-year">Study year</label>
            <div class="col-sm-3">
                <input type="text" id="input-study-year" placeholder="Năm học" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-email">Email</label>
            <div class="col-sm-9">
                <input type="text" id="input-email" placeholder="Email" class="form-control">
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_FINISH_AND_OK = 200;
    var gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnLayThongTinClick() {
        //B1 Thu thập thông tin

        //Kiểm tra dữ liệu

        //B3  API lấy danh sách sinh viên (Students)
        var vXmlHttp = new XMLHttpRequest();
        goiApiLayDanhSachSv(vXmlHttp);
        //B4 Xử lý hiển thị
        xuLyHienThiDanhSach(vXmlHttp);
    }


    function onBtnXemChiTietClick() {
        var vSinhVienIdObj = {
            sinhVienId: ""
        }
        //B1 Thu thập dữ liệu
              thuThapDuLieuId(vSinhVienIdObj);
        //B2 Kiểm tra dữ liệu
        var vDuLieuHopLe = kiemTraDuLieuId(vSinhVienIdObj);
        if (vDuLieuHopLe) {
            //B3 Gọi Api lấy thông tin sinh viên
            var vXmlHttp = new XMLHttpRequest();
            goiApiKiemTraIdSinhVien(vSinhVienIdObj, vXmlHttp);
            //B4 Xử lý hiển thị
            xuLyHienThiThongTinSv(vXmlHttp);
        }



    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function goiApiLayDanhSachSv(paramXmlHttpObj) {
        var vAPI_URL = gBASE_URL + "/students";
        paramXmlHttpObj.open("GET", vAPI_URL, false);
        paramXmlHttpObj.send();
        if (paramXmlHttpObj.status == gREQUEST_STATUS_FINISH_AND_OK) {
            console.log(paramXmlHttpObj.responseText);
        }
    }

    function xuLyHienThiDanhSach(paramXmlHttpObj) {
        var vDanhSachSvTraVe = JSON.parse(paramXmlHttpObj.responseText);
        var vElementSoSv = document.getElementById("span-num-students");
        var vElementDanhSachId = document.getElementById("span-id-student-list");
        var vSoSvTraVe = vDanhSachSvTraVe.length;
        //debugger;
        //for( var bI = 0;bI < vSoSvTraVe; bI ++){
        //   var bDanhSachId = vDanhSachSvTraVe[bI].id
        //}
        vElementSoSv.innerHTML = vSoSvTraVe;
        vElementDanhSachId.innerHTML = vDanhSachSvTraVe[0].id + "," + vDanhSachSvTraVe[1].id + "," + vDanhSachSvTraVe[2].id + "," + vDanhSachSvTraVe[3].id + "," + vDanhSachSvTraVe[4].id + "," + vDanhSachSvTraVe[5].id + "," + vDanhSachSvTraVe[6].id + "," + vDanhSachSvTraVe[7].id + "," + vDanhSachSvTraVe[8].id + "," + vDanhSachSvTraVe[9].id;
    }
    //Hàm thu thập dữ liệu
    function thuThapDuLieuId(paramSinhVienIdObj) {
        var vInputIdSinhVien = document.getElementById("input-student-id");
        paramSinhVienIdObj.sinhVienId = vInputIdSinhVien.value.trim();
    }
    //Hàm kiểm tra dữ liệu Id nhập vào form
    function kiemTraDuLieuId(paramSinhVienIdObj) {
        if (paramSinhVienIdObj.sinhVienId == "") {
            alert("Id chưa được nhập!");
            return false;
        }
        if (isNaN(paramSinhVienIdObj.sinhVienId)) {
            alert("Id phải là số!");
            return false;
        }
        return true;
    }
    //Hàm gọi Api kiểm tra id sinh viên
    function goiApiKiemTraIdSinhVien(paramSinhVienIdObj, paramXmlHttpObj) {
        var vAPI_URL = gBASE_URL + "/students/";
        var vStudentId = paramSinhVienIdObj.sinhVienId;

        //var vXmlHttp = new XMLHttpRequest();
        paramXmlHttpObj.open("GET", vAPI_URL + vStudentId, false);
        paramXmlHttpObj.send();

    }
    //Hàm xử lý hiển thị dựa trên mảng api trả về
    function xuLyHienThiThongTinSv(paramXmlHttpObj) {
        if (paramXmlHttpObj.status == gREQUEST_STATUS_FINISH_AND_OK) {
            console.log(paramXmlHttpObj.responseText);

            var vThongTinSinhVien = JSON.parse(paramXmlHttpObj.responseText);
            var vInputStudentCode = document.getElementById("input-student-code");
            var vInputUserName = document.getElementById("input-username");
            var vInputFirstName = document.getElementById("input-firstname");
            var vInputLastName = document.getElementById("input-lastname");
            var vInputBrithday = document.getElementById("input-birthday");
            var vInputStudyYear = document.getElementById("input-study-year");
            var vInputEmail = document.getElementById("input-email");
            vInputStudentCode.value = vThongTinSinhVien.studentCode;
            vInputUserName.value = vThongTinSinhVien.username;
            vInputFirstName.value = vThongTinSinhVien.firstname;
            vInputLastName.value = vThongTinSinhVien.lastname;
            vInputBrithday.value = vThongTinSinhVien.birthday;
            vInputStudyYear.value = vThongTinSinhVien.studyYear;
            vInputEmail.value = vThongTinSinhVien.email;
        }
        else {
            alert("Không tồn tại Sinh viên với id đã nhập")
        }
    }
</script>

</html>